/***************************************************************************
                          confdialog.cpp  -  description
                             -------------------
    begin                : May 7 22:18:34 BST 2004
    copyright            : (C) 2004 by KSmoothDock team
    email                : dangvd@yahoo.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <klocale.h>

#include "confdialog.h"

#include <qvariant.h>
#include <qpushbutton.h>
#include <qtabwidget.h>
#include <qwidget.h>
#include <qgroupbox.h>
#include <qbuttongroup.h>
#include <qlabel.h>
#include <qradiobutton.h>
#include <qcheckbox.h>
#include <qlineedit.h>
#include <qslider.h>
#include <kcolorbutton.h>
#include <knuminput.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>

#include <kmessagebox.h>
#include <kfontdialog.h>

#include "constants.h"
#include "ksmoothdock.h"


/*
 *  Constructs a ConfDialog as a child of 'parent', with the
 *  name 'name' and widget flags set to 'f'.
 *
 *  The dialog will by default be modeless, unless you set 'modal' to
 *  TRUE to construct a modal dialog.
 */
ConfDialog::ConfDialog( KSmoothDock* parent, const char* name, bool modal, WFlags fl )
    : QDialog( (QWidget*) parent, name, modal, fl )
{
    this->parent = parent;
    if ( !name )
	    setName( "KSmoothDock Preferences" );
    setSizeGripEnabled( TRUE );

    buttonApply = new QPushButton( this, "buttonApply" );
    buttonApply->setGeometry( QRect( 240, 530, 130, 30 ) );
    buttonApply->setAutoDefault( TRUE );
    buttonApply->setDefault( TRUE );

    buttonQuit = new QPushButton( this, "buttonQuit" );
    buttonQuit->setGeometry( QRect( 460, 530, 110, 30 ) );
    buttonQuit->setAutoDefault( TRUE );

    tabPrefs = new QTabWidget( this, "tabPrefs" );
    tabPrefs->setGeometry( QRect( 20, 10, 770, 510 ) );

    Widget2 = new QWidget( tabPrefs, "Widget2" );

    groupBox2 = new QGroupBox( Widget2, "groupBox2" );
    groupBox2->setGeometry( QRect( 30, 30, 670, 250 ) );

    textLabel1_3 = new QLabel( groupBox2, "textLabel1_3" );
    textLabel1_3->setGeometry( QRect( 160, 160, 261, 41 ) );

    textLabel7 = new QLabel( groupBox2, "textLabel7" );
    textLabel7->setGeometry( QRect( 80, 80, 171, 31 ) );

    textLabel9 = new QLabel( groupBox2, "textLabel9" );
    textLabel9->setGeometry( QRect( 80, 200, 141, 41 ) );

    textLabel6 = new QLabel( groupBox2, "textLabel6" );
    textLabel6->setGeometry( QRect( 80, 20, 340, 41 ) );

    cbPager = new QCheckBox( groupBox2, "cbPager" );
    cbPager->setGeometry( QRect( 30, 80, 20, 20 ) );

    cbTaskbar = new QCheckBox( groupBox2, "cbTaskbar" );
    cbTaskbar->setGeometry( QRect( 30, 130, 20, 20 ) );

    cbClock = new QCheckBox( groupBox2, "cbClock" );
    cbClock->setGeometry( QRect( 30, 210, 20, 20 ) );

    cbShowWinAllDesks = new QCheckBox( groupBox2, "cbShowWinAllDesks" );
    cbShowWinAllDesks->setGeometry( QRect( 110, 170, 20, 20 ) );

    cbQuickLaunch = new QCheckBox( groupBox2, "cbQuickLaunch" );
    cbQuickLaunch->setEnabled( FALSE );
    cbQuickLaunch->setGeometry( QRect( 30, 30, 20, 21 ) );
    cbQuickLaunch->setChecked( TRUE );

    textLabel2_3 = new QLabel( groupBox2, "textLabel2_3" );
    textLabel2_3->setGeometry( QRect( 80, 130, 70, 31 ) );
    tabPrefs->insertTab( Widget2, QString("") );

    Widget3 = new QWidget( tabPrefs, "Widget3" );

    groupBox1 = new QGroupBox( Widget3, "groupBox1" );
    groupBox1->setGeometry( QRect( 30, 30, 670, 200 ) );

    buttonGroup2 = new QButtonGroup( groupBox1, "buttonGroup2" );
    buttonGroup2->setGeometry( QRect( 10, 50, 360, 90 ) );
    buttonGroup2->setLineWidth( 0 );

    textLabel4 = new QLabel( buttonGroup2, "textLabel4" );
    textLabel4->setGeometry( QRect( 130, 40, 180, 40 ) );

    rbNormalZoom = new QRadioButton( buttonGroup2, "rbNormalZoom" );
    rbNormalZoom->setGeometry( QRect( 80, 0, 16, 21 ) );

    textLabel3 = new QLabel( buttonGroup2, "textLabel3" );
    textLabel3->setGeometry( QRect( 130, -10, 221, 41 ) );

    rbParabolicZoom = new QRadioButton( buttonGroup2, "rbParabolicZoom" );
    rbParabolicZoom->setGeometry( QRect( 80, 40, 16, 31 ) );

    textLabel1_2 = new QLabel( groupBox1, "textLabel1_2" );
    textLabel1_2->setGeometry( QRect( 90, 140, 490, 40 ) );

    grbParabolic = new QGroupBox( Widget3, "grbParabolic" );
    grbParabolic->setGeometry( QRect( 30, 270, 671, 90 ) );

    textLabel1_5 = new QLabel( grbParabolic, "textLabel1_5" );
    textLabel1_5->setGeometry( QRect( 100, 30, 490, 41 ) );

    cbGradualPZ = new QCheckBox( grbParabolic, "cbGradualPZ" );
    cbGradualPZ->setGeometry( QRect( 40, 40, 20, 20 ) );
    tabPrefs->insertTab( Widget3, QString("") );

    TabPage = new QWidget( tabPrefs, "TabPage" );

    groupBox3 = new QGroupBox( TabPage, "groupBox3" );
    groupBox3->setGeometry( QRect( 30, 30, 660, 150 ) );

    textLabel2_2 = new QLabel( groupBox3, "textLabel2_2" );
    textLabel2_2->setGeometry( QRect( 20, 40, 131, 31 ) );

    textLabel2_2_2 = new QLabel( groupBox3, "textLabel2_2_2" );
    textLabel2_2_2->setGeometry( QRect( 20, 90, 131, 31 ) );

    edtSmallIconNZ = new QLineEdit( groupBox3, "edtSmallIconNZ" );
    edtSmallIconNZ->setGeometry( QRect( 570, 30, 51, 31 ) );
    edtSmallIconNZ->setReadOnly( TRUE );

    edtBigIconNZ = new QLineEdit( groupBox3, "edtBigIconNZ" );
    edtBigIconNZ->setGeometry( QRect( 570, 90, 51, 31 ) );
    edtBigIconNZ->setReadOnly( TRUE );

    sldSmallIconNZ = new QSlider( groupBox3, "sldSmallIconNZ" );
    sldSmallIconNZ->setGeometry( QRect( 160, 40, 340, 24 ) );
    sldSmallIconNZ->setOrientation( QSlider::Horizontal );
    sldSmallIconNZ->setTickmarks( QSlider::NoMarks );

    sldBigIconNZ = new QSlider( groupBox3, "sldBigIconNZ" );
    sldBigIconNZ->setGeometry( QRect( 160, 90, 340, 24 ) );
    sldBigIconNZ->setOrientation( QSlider::Horizontal );
    sldBigIconNZ->setTickmarks( QSlider::NoMarks );

    groupBox4 = new QGroupBox( TabPage, "groupBox4" );
    groupBox4->setGeometry( QRect( 30, 220, 660, 140 ) );

    textLabel2_2_3 = new QLabel( groupBox4, "textLabel2_2_3" );
    textLabel2_2_3->setGeometry( QRect( 20, 30, 131, 31 ) );

    textLabel2_2_2_2 = new QLabel( groupBox4, "textLabel2_2_2_2" );
    textLabel2_2_2_2->setGeometry( QRect( 20, 80, 110, 31 ) );

    edtSmallIconPZ = new QLineEdit( groupBox4, "edtSmallIconPZ" );
    edtSmallIconPZ->setGeometry( QRect( 570, 30, 51, 31 ) );
    edtSmallIconPZ->setReadOnly( TRUE );

    edtBigIconPZ = new QLineEdit( groupBox4, "edtBigIconPZ" );
    edtBigIconPZ->setGeometry( QRect( 570, 80, 51, 31 ) );
    edtBigIconPZ->setReadOnly( TRUE );

    sldSmallIconPZ = new QSlider( groupBox4, "sldSmallIconPZ" );
    sldSmallIconPZ->setGeometry( QRect( 160, 30, 340, 24 ) );
    sldSmallIconPZ->setOrientation( QSlider::Horizontal );
    sldSmallIconPZ->setTickmarks( QSlider::NoMarks );

    sldBigIconPZ = new QSlider( groupBox4, "sldBigIconPZ" );
    sldBigIconPZ->setGeometry( QRect( 160, 80, 340, 24 ) );
    sldBigIconPZ->setOrientation( QSlider::Horizontal );
    sldBigIconPZ->setTickmarks( QSlider::NoMarks );
    tabPrefs->insertTab( TabPage, QString("") );

    TabPage_2 = new QWidget( tabPrefs, "TabPage_2" );

    groupBox5 = new QGroupBox( TabPage_2, "groupBox5" );
    groupBox5->setGeometry( QRect( 50, 10, 640, 130 ) );

    textLabel3_2 = new QLabel( groupBox5, "textLabel3_2" );
    textLabel3_2->setGeometry( QRect( 71, 32, 121, 31 ) );

    textLabel4_2 = new QLabel( groupBox5, "textLabel4_2" );
    textLabel4_2->setGeometry( QRect( 130, 80, 110, 31 ) );

    btnBorderColor = new KColorButton( groupBox5, "btnBorderColor" );
    btnBorderColor->setGeometry( QRect( 250, 70, 60, 40 ) );

    cbBorders = new QCheckBox( groupBox5, "cbBorders" );
    cbBorders->setGeometry( QRect( 30, 40, 20, 20 ) );

    groupBox6 = new QGroupBox( TabPage_2, "groupBox6" );
    groupBox6->setGeometry( QRect( 50, 160, 640, 250 ) );

    textLabel6_2 = new QLabel( groupBox6, "textLabel6_2" );
    textLabel6_2->setGeometry( QRect( 40, 80, 131, 41 ) );

    textLabel7_2 = new QLabel( groupBox6, "textLabel7_2" );
    textLabel7_2->setGeometry( QRect( 40, 120, 171, 51 ) );

    textLabel5_2 = new QLabel( groupBox6, "textLabel5_2" );
    textLabel5_2->setGeometry( QRect( 40, 40, 141, 31 ) );

    textLabel7_2_2 = new QLabel( groupBox6, "textLabel7_2_2" );
    textLabel7_2_2->setGeometry( QRect( 40, 170, 171, 51 ) );

    btnBgColor = new KColorButton( groupBox6, "btnBgColor" );
    btnBgColor->setGeometry( QRect( 250, 30, 60, 40 ) );

    btnSepColor = new KColorButton( groupBox6, "btnSepColor" );
    btnSepColor->setGeometry( QRect( 250, 80, 60, 40 ) );

    btnActiveDeskColor = new KColorButton( groupBox6, "btnActiveDeskColor" );
    btnActiveDeskColor->setGeometry( QRect( 250, 130, 60, 40 ) );

    btnInactiveDeskColor = new KColorButton( groupBox6, "btnInactiveDeskColor" );
    btnInactiveDeskColor->setGeometry( QRect( 250, 180, 60, 40 ) );
    tabPrefs->insertTab( TabPage_2, QString("") );

    TabPage_3 = new QWidget( tabPrefs, "TabPage_3" );

    groupBox7 = new QGroupBox( TabPage_3, "groupBox7" );
    groupBox7->setGeometry( QRect( 30, 30, 640, 71 ) );

    textLabel9_2 = new QLabel( groupBox7, "textLabel9_2" );
    textLabel9_2->setGeometry( QRect( 60, 30, 395, 31 ) );

    cbNotification = new QCheckBox( groupBox7, "cbNotification" );
    cbNotification->setGeometry( QRect( 30, 30, 20, 20 ) );

    groupBox10 = new QGroupBox( TabPage_3, "groupBox10" );
    groupBox10->setGeometry( QRect( 30, 130, 640, 90 ) );

    textLabel10 = new QLabel( groupBox10, "textLabel10" );
    textLabel10->setGeometry( QRect( 30, 30, 110, 40 ) );

    edtOpacity = new QLineEdit( groupBox10, "edtOpacity" );
    edtOpacity->setGeometry( QRect( 540, 30, 51, 31 ) );
    edtOpacity->setReadOnly( TRUE );

    sldOpacity = new QSlider( groupBox10, "sldOpacity" );
    sldOpacity->setGeometry( QRect( 150, 40, 340, 24 ) );
    sldOpacity->setMaxValue( 100 );
    sldOpacity->setOrientation( QSlider::Horizontal );
    sldOpacity->setTickmarks( QSlider::NoMarks );
    sldOpacity->setTickInterval( 0 );

    groupBox9 = new QGroupBox( TabPage_3, "groupBox9" );
    groupBox9->setGeometry( QRect( 30, 250, 640, 130 ) );

    textLabel1 = new QLabel( groupBox9, "textLabel1" );
    textLabel1->setGeometry( QRect( 60, 30, 201, 31 ) );

    textLabel11 = new QLabel( groupBox9, "textLabel11" );
    textLabel11->setGeometry( QRect( 100, 70, 200, 31 ) );

    intScrWidth = new KIntNumInput( groupBox9, "intScrWidth" );
    intScrWidth->setGeometry( QRect( 340, 70, 113, 27 ) );

    cbXinerama = new QCheckBox( groupBox9, "cbXinerama" );
    cbXinerama->setGeometry( QRect( 30, 30, 20, 20 ) );
    tabPrefs->insertTab( TabPage_3, QString("") );

    TabPage_4 = new QWidget( tabPrefs, "TabPage_4" );

    textLabel1_4 = new QLabel( TabPage_4, "textLabel1_4" );
    textLabel1_4->setGeometry( QRect( 60, 10, 140, 41 ) );

    cbTooltips = new QCheckBox( TabPage_4, "cbTooltips" );
    cbTooltips->setGeometry( QRect( 20, 20, 20, 20 ) );

    grbTooltips = new QGroupBox( TabPage_4, "grbTooltips" );
    grbTooltips->setGeometry( QRect( 20, 50, 730, 400 ) );

    groupBox13 = new QGroupBox( grbTooltips, "groupBox13" );
    groupBox13->setGeometry( QRect( 20, 21, 240, 360 ) );

    textLabel3_3 = new QLabel( groupBox13, "textLabel3_3" );
    textLabel3_3->setGeometry( QRect( 10, 90, 120, 51 ) );

    textLabel2 = new QLabel( groupBox13, "textLabel2" );
    textLabel2->setGeometry( QRect( 10, 30, 110, 41 ) );

    ttColor = new KColorButton( groupBox13, "ttColor" );
    ttColor->setGeometry( QRect( 150, 30, 60, 41 ) );

    ttBgColor = new KColorButton( groupBox13, "ttBgColor" );
    ttBgColor->setGeometry( QRect( 150, 90, 61, 41 ) );

    ttFont = new KFontChooser( grbTooltips, "ttFont" );
    ttFont->setGeometry( QRect( 280, 20, 430, 360 ) );
    tabPrefs->insertTab( TabPage_4, QString("") );

    TabPage_5 = new QWidget( tabPrefs, "TabPage_5" );

    buttonGroup3 = new QButtonGroup( TabPage_5, "buttonGroup3" );
    buttonGroup3->setGeometry( QRect( 20, 0, 730, 80 ) );

    textLabel4_3 = new QLabel( buttonGroup3, "textLabel4_3" );
    textLabel4_3->setGeometry( QRect( 90, 20, 101, 20 ) );

    textLabel5 = new QLabel( buttonGroup3, "textLabel5" );
    textLabel5->setGeometry( QRect( 90, 50, 170, 21 ) );

    rb24 = new QRadioButton( buttonGroup3, "rb24" );
    rb24->setGeometry( QRect( 29, 20, 20, 20 ) );

    rb12 = new QRadioButton( buttonGroup3, "rb12" );
    rb12->setGeometry( QRect( 29, 50, 20, 20 ) );

    groupBox14 = new QGroupBox( TabPage_5, "groupBox14" );
    groupBox14->setGeometry( QRect( 20, 80, 730, 390 ) );

    textLabel2_4 = new QLabel( groupBox14, "textLabel2_4" );
    textLabel2_4->setGeometry( QRect( 30, 30, 110, 41 ) );

    btnClockTextColor = new KColorButton( groupBox14, "btnClockTextColor" );
    btnClockTextColor->setGeometry( QRect( 150, 30, 60, 41 ) );

    fontClockText = new KFontChooser( groupBox14, "fontClockText" );
    fontClockText->setGeometry( QRect( 270, 20, 440, 357 ) );
    tabPrefs->insertTab( TabPage_5, QString("") );
    languageChange();
    resize( QSize(810, 572).expandedTo(minimumSizeHint()) );
    clearWState( WState_Polished );

    // init values
		
		sldSmallIconNZ->setMinValue(16);
    sldSmallIconNZ->setMaxValue(48);
		sldBigIconNZ->setMinValue(24);
    sldBigIconNZ->setMaxValue(64);
		
		sldSmallIconPZ->setMinValue(16);
    sldSmallIconPZ->setMaxValue(48);
		sldBigIconPZ->setMinValue(32);
    sldBigIconPZ->setMaxValue(144);

		cbShowWinAllDesks->setEnabled(cbTaskbar->isChecked());
		btnBorderColor->setEnabled(cbBorders->isChecked());
		intScrWidth->setEnabled(cbXinerama->isChecked());
		grbTooltips->setEnabled(cbTooltips->isChecked());
    grbParabolic->setEnabled(rbParabolicZoom->isChecked());

    // init values of slider displays
    
    edtOpacity->setText(QString::number(sldOpacity->value()));
    edtSmallIconNZ->setText(QString::number(sldSmallIconNZ->value()));
    edtBigIconNZ->setText(QString::number(sldBigIconNZ->value()));
    edtSmallIconPZ->setText(QString::number(sldSmallIconPZ->value()));
    edtBigIconPZ->setText(QString::number(sldBigIconPZ->value()));

    // signals and slots connections

    connect( cbTaskbar, SIGNAL( stateChanged(int) ), this, SLOT( cbTaskbar_stateChanged(int) ) );
    connect( buttonQuit, SIGNAL( clicked() ), this, SLOT( buttonQuit_clicked() ) );
    connect( cbBorders, SIGNAL( stateChanged(int) ), this, SLOT( cbBorders_stateChanged(int) ) );
    connect( cbXinerama, SIGNAL( stateChanged(int) ), this, SLOT( cbXinerama_stateChanged(int) ) );
    connect( buttonApply, SIGNAL( clicked() ), this, SLOT( buttonApply_clicked() ) );
    connect( sldOpacity, SIGNAL( valueChanged(int) ), this, SLOT( sldOpacity_valueChanged(int) ) );
    connect( sldSmallIconNZ, SIGNAL( valueChanged(int) ), this, SLOT( sldSmallIconNZ_valueChanged(int) ) );
    connect( sldBigIconNZ, SIGNAL( valueChanged(int) ), this, SLOT( sldBigIconNZ_valueChanged(int) ) );
    connect( sldSmallIconPZ, SIGNAL( valueChanged(int) ), this, SLOT( sldSmallIconPZ_valueChanged(int) ) );
    connect( sldBigIconPZ, SIGNAL( valueChanged(int) ), this, SLOT( sldBigIconPZ_valueChanged(int) ) );
		connect( cbTooltips, SIGNAL( stateChanged(int) ), this, SLOT( cbTooltips_stateChanged(int) ) );
    connect( rbParabolicZoom, SIGNAL( stateChanged(int) ), this, SLOT( rbParabolicZoom_stateChanged(int) ) );
}

/*
 *  Destroys the object and frees any allocated resources
 */
ConfDialog::~ConfDialog()
{
    // no need to delete child widgets, Qt does it all for us
}

/*
 *  Sets the strings of the subwidgets using the current
 *  language.
 */
void ConfDialog::languageChange()
{
    setCaption( tr2i18n( "KSmoothDock Preferences" ) );
    buttonApply->setText( tr2i18n( "&Apply" ) );
    buttonApply->setAccel( QKeySequence( tr2i18n( "Alt+A" ) ) );
    buttonQuit->setText( tr2i18n( "&Close" ) );
    buttonQuit->setAccel( QKeySequence( tr2i18n( "Alt+C" ) ) );
    groupBox2->setTitle( tr2i18n( "The components of KSmoothDock you want to use" ) );
    textLabel1_3->setText( tr2i18n( "Show windows from all desktops" ) );
    textLabel7->setText( tr2i18n( "Pager" ) );
    textLabel9->setText( tr2i18n( "Clock" ) );
    textLabel6->setText( tr2i18n( "Quick launch menu (always enabled by default)" ) );
    cbPager->setText( QString::null );
    cbTaskbar->setText( tr2i18n( "checkBox3" ) );
    cbClock->setText( tr2i18n( "checkBox4" ) );
    cbShowWinAllDesks->setText( tr2i18n( "checkBox5" ) );
    cbQuickLaunch->setText( QString::null );
    textLabel2_3->setText( tr2i18n( "Taskbar" ) );
    tabPrefs->changeTab( Widget2, tr2i18n( "Dock Components" ) );
    textLabel1_2->setText( tr2i18n( "<font color=\"#aa0000\">Note: This option requires the dock to restart for the change to take effect.</font>" ) );
    groupBox1->setTitle( tr2i18n( "The zooming mode you want to use" ) );
    buttonGroup2->setTitle( QString::null );
    textLabel4->setText( tr2i18n( "Parabolic Zooming Mode" ) );
    rbParabolicZoom->setText( tr2i18n( "radioButton2" ) );
    rbNormalZoom->setText( tr2i18n( "radioButton1" ) );
    textLabel3->setText( tr2i18n( "Normal Smooth Zooming Mode" ) );
    grbParabolic->setTitle( tr2i18n( "Parabolic Zooming Mode Options" ) );
    textLabel1_5->setText( tr2i18n( "Grow and shrink KSmoothDock gradually in zoom-in and zoom-out events" ) );
    cbGradualPZ->setText( tr2i18n( "checkBox10" ) );
    tabPrefs->changeTab( Widget3, tr2i18n( "Icon Zooming" ) );    
    
    groupBox3->setTitle( tr2i18n( "Normal Zooming Mode" ) );
    textLabel2_2->setText( tr2i18n( "Small icon size" ) );
    textLabel2_2_2->setText( tr2i18n( "Big icon size" ) );
    groupBox4->setTitle( tr2i18n( "Parabolic Zooming Mode" ) );
    textLabel2_2_3->setText( tr2i18n( "Small icon size" ) );
    textLabel2_2_2_2->setText( tr2i18n( "Big icon size" ) );
    tabPrefs->changeTab( TabPage, tr2i18n( "Icon Sizes" ) );
    groupBox5->setTitle( tr2i18n( "Borders" ) );
    textLabel3_2->setText( tr2i18n( "Show borders" ) );
    textLabel4_2->setText( tr2i18n( "Borders color" ) );
    btnBorderColor->setText( QString::null );
    cbBorders->setText( tr2i18n( "cbXinerama" ) );
    groupBox6->setTitle( tr2i18n( "Colors" ) );
    textLabel6_2->setText( tr2i18n( "Separator color" ) );
    textLabel7_2->setText( tr2i18n( "Active desktop color" ) );
    textLabel5_2->setText( tr2i18n( "Background color" ) );
    textLabel7_2_2->setText( tr2i18n( "Inactive desktop color" ) );
    btnBgColor->setText( QString::null );
    btnSepColor->setText( QString::null );
    btnActiveDeskColor->setText( QString::null );
    btnInactiveDeskColor->setText( QString::null );
    tabPrefs->changeTab( TabPage_2, tr2i18n( "Appearances" ) );
    groupBox7->setTitle( tr2i18n( "Notification" ) );
    textLabel9_2->setText( tr2i18n( "Show notification when a running task's window title changed" ) );
    cbNotification->setText( tr2i18n( "checkBox9" ) );
    groupBox10->setTitle( tr2i18n( "Opacity" ) );
    textLabel10->setText( tr2i18n( "Dock Opacity" ) );
    groupBox9->setTitle( tr2i18n( "Xinerama support" ) );
    cbXinerama->setText( tr2i18n( "cbXinerama" ) );
    textLabel1->setText( tr2i18n( "Enable Xinerama support" ) );
    textLabel11->setText( tr2i18n( "Left monitor's screen width" ) );
    tabPrefs->changeTab( TabPage_3, tr2i18n( "Misc." ) );
    grbTooltips->setTitle( tr2i18n( "Tooltips font" ) );
    groupBox13->setTitle( tr2i18n( "Colors" ) );
    textLabel3_3->setText( tr2i18n( "Background color" ) );
    textLabel2->setText( tr2i18n( "Text color" ) );
    ttColor->setText( QString::null );
    ttBgColor->setText( QString::null );
    textLabel1_4->setText( tr2i18n( "Show tooltips" ) );
    cbTooltips->setText( tr2i18n( "checkBox14" ) );
    tabPrefs->changeTab( TabPage_4, tr2i18n( "Tooltips" ) );
    buttonGroup3->setTitle( tr2i18n( "Clock style" ) );
    textLabel4_3->setText( tr2i18n( "24 hours clock" ) );
    textLabel5->setText( tr2i18n( "12 hours clock (AM, PM)" ) );
    rb24->setText( tr2i18n( "radioButton5" ) );
    rb12->setText( tr2i18n( "radioButton6" ) );
    groupBox14->setTitle( tr2i18n( "Clock font" ) );
    textLabel2_4->setText( tr2i18n( "Text color" ) );
    btnClockTextColor->setText( QString::null );
    tabPrefs->changeTab( TabPage_5, tr2i18n( "Clock" ) );
}

void ConfDialog::cbTaskbar_stateChanged( int )
{
  cbShowWinAllDesks->setEnabled(cbTaskbar->isChecked());
}


void ConfDialog::buttonQuit_clicked()
{
    this->reject();
}

void ConfDialog::cbBorders_stateChanged( int )
{
  btnBorderColor->setEnabled(cbBorders->isChecked());
}

void ConfDialog::cbXinerama_stateChanged( int ) {
  intScrWidth->setEnabled(cbXinerama->isChecked());
}

void ConfDialog::cbTooltips_stateChanged( int ) {
	grbTooltips->setEnabled(cbTooltips->isChecked());
}

void ConfDialog::rbParabolicZoom_stateChanged( int ) {
  grbParabolic->setEnabled(rbParabolicZoom->isChecked());
}

void ConfDialog::buttonApply_clicked()
{
  int i = tabPrefs->currentPageIndex();

  switch (i) {
    case 0:
			applyComponents();      
      break;
    case 1:
      applyZoomMode();
      break;
    case 2:
      applyIconSizes();
      break;
    case 3:
      applyAppearances();
      break;
    case 4:
      applyMisc();
      break;
		case 5:
			applyTooltips();
			break;
		case 6:
			applyClock();
			break;
    default:
      break;
  }
}

void ConfDialog::applyZoomMode() {
  if (getZoomMode() != parent->getZoomMode()) {
    parent->saveConf(getZoomMode());
    KMessageBox::information(this, "You need to restart the program for this change to take effect.");
  } else if (getZoomMode() == PARABOLIC_ZOOM && cbGradualPZ->isChecked() != parent->getGradualPZ()) {
    parent->setGradualPZ(cbGradualPZ->isChecked());
    parent->saveConf(PARABOLIC_ZOOM);
  }
}

void ConfDialog::applyComponents() {
  parent->setShowPager(cbPager->isChecked());
  parent->setShowTaskbar(cbTaskbar->isChecked());
  parent->setShowWinAllDesks(cbShowWinAllDesks->isChecked());
  parent->setShowClock(cbClock->isChecked());

  parent->updateComponents();

  parent->saveConf(getZoomMode());
}

void ConfDialog::applyIconSizes() {
  bool updateDock = (parent->getZoomMode() == this->getZoomMode());
  
  parent->setSmallIconSizeNZ(sldSmallIconNZ->value());
  parent->setBigIconSizeNZ(sldBigIconNZ->value());

  parent->setSmallIconSizePZ(sldSmallIconPZ->value());
  parent->setBigIconSizePZ(sldBigIconPZ->value());

  if (updateDock) // redrawing if needed
    parent->updateIconSizes();

  parent->saveConf(getZoomMode());
}

void ConfDialog::applyAppearances() {
  bool reloadBg = (parent->getBgColor() != btnBgColor->color());
  
  parent->setShowBorders(cbBorders->isChecked());
  parent->setBorderColor(btnBorderColor->color());
     
  parent->setBgColor(btnBgColor->color());
  parent->setSepColor(btnSepColor->color());
  parent->setActiveDeskColor(btnActiveDeskColor->color());
  parent->setInactiveDeskColor(btnInactiveDeskColor->color());  

  if (reloadBg) { // if the background color change we need to reload background image
    parent->updateBackground();
    parent->setStateBelow();  
  } else { // otherwise just repaint
    parent->update();
  }
  parent->saveConf(getZoomMode()); 
}

void ConfDialog::applyMisc() {
  parent->setShowNotification(cbNotification->isChecked());

  if (parent->getDockOpacity() != sldOpacity->value()) {
    parent->setDockOpacity(sldOpacity->value());
    parent->updateBackground();
    parent->setStateBelow();   
  }
  
  if (cbXinerama->isChecked()) {
    if (parent->getScrWidth() != intScrWidth->value()) {
      parent->setScrWidth(intScrWidth->value());      
      parent->updateScrWidth();
    }
  } else {
    if (parent->getScrWidth() != 0) {
      parent->setScrWidth(0);
      parent->updateScrWidth();
    }
  }
  
  parent->saveConf(getZoomMode());
}	

void ConfDialog::applyTooltips() {
	parent->setShowToolTip(cbTooltips->isChecked());
	parent->setToolTipFontColor(ttColor->color());	
	parent->setToolTipFontBgColor(ttBgColor->color());
	
	QFont font = ttFont->font();	
	parent->setToolTipFontFace(font.family());
	parent->setToolTipFontSize(font.pointSize());
	parent->setToolTipFontIsBold(font.bold());	
	parent->setToolTipFontIsItalic(font.italic());
	
	parent->updateTooltips();
	
	parent->saveConf(getZoomMode());
}

void ConfDialog::applyClock() {
	parent->setUse24HourClock(rb24->isChecked());
	parent->setClockFontColor(btnClockTextColor->color());
	
	QFont font = fontClockText->font();
	parent->setClockFontFace(font.family());
	parent->setClockFontSize(font.pointSize());
	parent->setClockFontIsBold(font.bold());
	parent->setClockFontIsItalic(font.italic());
	parent->update();
	
	parent->saveConf(getZoomMode());
}

int ConfDialog::getZoomMode() {
  if (rbNormalZoom->isChecked())
    return NORMAL_ZOOM;
  else
    return PARABOLIC_ZOOM;
}

void ConfDialog::sldOpacity_valueChanged( int )
{
    edtOpacity->setText(QString::number(sldOpacity->value()));
}


void ConfDialog::sldSmallIconNZ_valueChanged( int )
{
    edtSmallIconNZ->setText(QString::number(sldSmallIconNZ->value()));
}


void ConfDialog::sldBigIconNZ_valueChanged( int )
{
    edtBigIconNZ->setText(QString::number(sldBigIconNZ->value()));
}


void ConfDialog::sldSmallIconPZ_valueChanged( int )
{
    edtSmallIconPZ->setText(QString::number(sldSmallIconPZ->value()));
}


void ConfDialog::sldBigIconPZ_valueChanged( int )
{
    edtBigIconPZ->setText(QString::number(sldBigIconPZ->value()));
}

// update configuration values from parent

void ConfDialog::updateValues() {
  rbNormalZoom->setChecked(parent->getZoomMode() == NORMAL_ZOOM);
  rbParabolicZoom->setChecked(parent->getZoomMode() == PARABOLIC_ZOOM);
  cbGradualPZ->setChecked(parent->getGradualPZ());

  cbPager->setChecked(parent->getShowPager());
  cbTaskbar->setChecked(parent->getShowTaskbar());
  cbShowWinAllDesks->setChecked(parent->getShowWinAllDesks());
  cbClock->setChecked(parent->getShowClock());

  sldSmallIconNZ->setValue(parent->getSmallIconSizeNZ());
  sldBigIconNZ->setValue(parent->getBigIconSizeNZ());

  sldSmallIconPZ->setValue(parent->getSmallIconSizePZ());
  sldBigIconPZ->setValue(parent->getBigIconSizePZ());

  cbBorders->setChecked(parent->getShowBorders());
  btnBorderColor->setColor(parent->getBorderColor());

  btnBgColor->setColor(parent->getBgColor());
  btnSepColor->setColor(parent->getSepColor());
  btnActiveDeskColor->setColor(parent->getActiveDeskColor());
  btnInactiveDeskColor->setColor(parent->getInactiveDeskColor());  

  cbNotification->setChecked(parent->getShowNotification());
  sldOpacity->setValue(parent->getDockOpacity());
  cbXinerama->setChecked(parent->getScrWidth() != 0);
  intScrWidth->setValue(parent->getScrWidth());
	
	cbTooltips->setChecked(parent->getShowToolTip());
	ttColor->setColor(parent->getToolTipFontColor());
	ttBgColor->setColor(parent->getToolTipFontBgColor());
	
	QFont font = QFont(parent->getToolTipFontFace(), parent->getToolTipFontSize());
	font.setBold(parent->getToolTipFontIsBold());
	font.setItalic(parent->getToolTipFontIsItalic());
	ttFont->setFont(font);
	
	rb24->setChecked(parent->getUse24HourClock());
	rb12->setChecked(!parent->getUse24HourClock());	
	btnClockTextColor->setColor(parent->getClockFontColor());
	
	QFont font2 = QFont(parent->getClockFontFace(), parent->getClockFontSize());
	font2.setBold(parent->getClockFontIsBold());
	font2.setItalic(parent->getClockFontIsItalic());
	fontClockText->setFont(font2);
}


#include "confdialog.moc"
