/***************************************************************************
 *   Copyright (C) 2004 by Viet Dung Dang                                  *
 *   dangvd@yahoo.com                                                      *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef CONSTANTS_H
#define CONSTANTS_H

const int NORMAL_ZOOM = 1;
const int PARABOLIC_ZOOM = 2;

const int MAX_ICONS = 100; // max number of icons
const int MAX_DESKTOPS = 32; // max number of virtual desktops
const int UPDATE_DIST = 3; // update when x - last_x <= UPDATE_DIST
const int DEF_SMALL_SIZE_NZ = 28; // default small icon size normal zoom
const int DEF_BIG_SIZE_NZ = 48; // default big icon size
const int DEF_SMALL_SIZE_PZ = 24; // default small icon size parabolic zoom
const int DEF_BIG_SIZE_PZ = 80; // default big icon size
const int DEF_DOCK_OPACITY = 42; // default dock opacity

const int HIDDEN_WIDTH = 15; // the width of the dock when in hidden mode
const int MAX_HIDDEN_HEIGHT = 100;

const int TOOLTIP_SPACE = 5; // the space between the tooltip and the dock

// normal mode

const int ANIM_TOTAL_STEP = 10;
const int ANIM_STEP_TIME = 16;
const int ANIM_TOTAL_TIME = ANIM_TOTAL_STEP * ANIM_STEP_TIME;

// parabolic mode

const int ANIM_TOTAL_STEP_PZ = 20;
const int ANIM_STEP_TIME_PZ = 16;
const int ANIM_TOTAL_TIME_PZ = ANIM_TOTAL_STEP_PZ * ANIM_STEP_TIME_PZ;

const int SPACE_W = 1; // space between quick launchers and tasks (the seperator)

const int MAX_LEN = 256;

const int ON_CHANGE_ANIM_INTERVAL = 1000; // animation's interval

const int SIZE_INC = 1;

const int CONF_MENU_ICON_SIZE = 32;

const int PAGER_ICON_BASE_WIDTH = 128; // used in generating desktop pager icon

enum WindowMode {HIDDEN, MINIMISED, MAXIMISED};

// const int ANIM_TOTAL_STEP = 10;
// const int ANIM_STEP_TIME = 16;
// const int ANIM_TOTAL_TIME = ANIM_TOTAL_STEP * ANIM_STEP_TIME;





#endif
