/***************************************************************************
 *   Copyright (C) 2004 by KSmoothDock team                                *
 *   dangvd@yahoo.com                                                      *
 *   Based on xosd.h (C) 2004 by KoolDock team                             * 
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef TOOLTIP_H
#define TOOLTIP_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <qstring.h>
#include <qwidget.h>
#include <qfont.h>
#include <qcolor.h>

#include <netwm.h>
#include <kwin.h>

/**
@author KSmoothDock team
*/
class ToolTip : public QWidget
{
Q_OBJECT
   public:
      ToolTip(QWidget* parent=0, const char *name=0);

      virtual ~ToolTip();
      void setText(QString t);
      void setFontFace(QString fontFace);
      void setItalic(bool val);
      void setBold(bool val);
      void setSize(int size);
      void setColor(QColor color);
			void setBgColor(QColor color); 
			
			void doUpdateGeometry();
			
			int w, h;

   private:
	 		int fontSize;      
      int fontStyle;
      QString fontFamily;
	 
      NETWinInfo *info;
      QString text;
      QFont font;
      QColor fontColor;
			QColor bgColor;

   protected:
      void paintEvent(QPaintEvent *);
};

#endif
