/***************************************************************************
                          welcomedialog.cpp  -  description
                             -------------------
    begin                : May 7 22:18:34 BST 2004
    copyright            : (C) 2004 by KSmoothDock team
    email                : dangvd@yahoo.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#include <klocale.h>

#include <qvariant.h>
#include <qgroupbox.h>
#include <qlabel.h>
#include <qbuttongroup.h>
#include <qradiobutton.h>
#include <qcheckbox.h>
#include <qpushbutton.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>

#include "constants.h"
#include "welcomedialog.h"

/*
 *  Constructs a WelcomeDialog as a child of 'parent', with the
 *  name 'name' and widget flags set to 'f'.
 *
 *  The dialog will by default be modeless, unless you set 'modal' to
 *  TRUE to construct a modal dialog.
 */
WelcomeDialog::WelcomeDialog( QWidget* parent, const char* name, bool modal, WFlags fl )
    : QDialog( parent, name, modal, fl )
{
    if ( !name )
	setName( "WelcomeDialog" );

    groupBox1 = new QGroupBox( this, "groupBox1" );
    groupBox1->setGeometry( QRect( 30, 120, 490, 120 ) );

    buttonGroup2 = new QButtonGroup( groupBox1, "buttonGroup2" );
    buttonGroup2->setGeometry( QRect( 20, 30, 340, 70 ) );
    buttonGroup2->setLineWidth( 0 );

    textLabel3 = new QLabel( buttonGroup2, "textLabel3" );
    textLabel3->setGeometry( QRect( 60, -10, 221, 41 ) );

    textLabel4 = new QLabel( buttonGroup2, "textLabel4" );
    textLabel4->setGeometry( QRect( 60, 30, 180, 40 ) );

    rbParabolicZoom = new QRadioButton( buttonGroup2, "rbParabolicZoom" );
    rbParabolicZoom->setGeometry( QRect( 10, 40, 20, 20 ) );

    rbNormalZoom = new QRadioButton( buttonGroup2, "rbNormalZoom" );
    rbNormalZoom->setGeometry( QRect( 10, 0, 16, 16 ) );
    rbNormalZoom->setChecked( TRUE );

    textLabel1 = new QLabel( this, "textLabel1" );
    textLabel1->setGeometry( QRect( 30, 0, 490, 61 ) );

    textLabel2 = new QLabel( this, "textLabel2" );
    textLabel2->setGeometry( QRect( 30, 60, 490, 41 ) );

    pushButton1 = new QPushButton( this, "pushButton1" );
    pushButton1->setGeometry( QRect( 210, 500, 121, 41 ) );

    groupBox2 = new QGroupBox( this, "groupBox2" );
    groupBox2->setGeometry( QRect( 30, 260, 490, 230 ) );

    textLabel6 = new QLabel( groupBox2, "textLabel6" );
    textLabel6->setGeometry( QRect( 80, 30, 340, 41 ) );

    textLabel7 = new QLabel( groupBox2, "textLabel7" );
    textLabel7->setGeometry( QRect( 80, 70, 171, 31 ) );

    textLabel1_3 = new QLabel( groupBox2, "textLabel1_3" );
    textLabel1_3->setGeometry( QRect( 160, 140, 261, 41 ) );

    textLabel9 = new QLabel( groupBox2, "textLabel9" );
    textLabel9->setGeometry( QRect( 80, 180, 141, 41 ) );

    textLabel2_3 = new QLabel( groupBox2, "textLabel2_3" );
    textLabel2_3->setGeometry( QRect( 80, 110, 131, 31 ) );

    cbPager = new QCheckBox( groupBox2, "cbPager" );
    cbPager->setGeometry( QRect( 30, 80, 16, 16 ) );

    cbTaskbar = new QCheckBox( groupBox2, "cbTaskbar" );
    cbTaskbar->setGeometry( QRect( 30, 120, 16, 16 ) );

    cbShowWinAllDesks = new QCheckBox( groupBox2, "cbShowWinAllDesks" );
    cbShowWinAllDesks->setGeometry( QRect( 110, 150, 16, 16 ) );

    cbClock = new QCheckBox( groupBox2, "cbClock" );
    cbClock->setGeometry( QRect( 30, 190, 16, 16 ) );

    cbQuickLaunch = new QCheckBox( groupBox2, "cbQuickLaunch" );
    cbQuickLaunch->setEnabled( FALSE );
    cbQuickLaunch->setGeometry( QRect( 30, 40, 16, 21 ) );
    cbQuickLaunch->setChecked( TRUE );
    languageChange();
    resize( QSize(550, 552).expandedTo(minimumSizeHint()) );
    clearWState( WState_Polished );

    // signals and slots connections
    connect( pushButton1, SIGNAL( clicked() ), this, SLOT( pushButton1_clicked() ) );
}

/*
 *  Destroys the object and frees any allocated resources
 */
WelcomeDialog::~WelcomeDialog()
{
    // no need to delete child widgets, Qt does it all for us
}

/*
 *  Sets the strings of the subwidgets using the current
 *  language.
 */
void WelcomeDialog::languageChange()
{
    setCaption( tr2i18n( "Welcome to KSmoothDock!" ) );
    groupBox1->setTitle( tr2i18n( "The zooming mode you want to use" ) );
    buttonGroup2->setTitle( QString::null );
    textLabel3->setText( tr2i18n( "Normal Smooth Zooming Mode" ) );
    textLabel4->setText( tr2i18n( "Parabolic Zooming Mode" ) );
    rbParabolicZoom->setText( tr2i18n( "radioButton2" ) );
    rbNormalZoom->setText( tr2i18n( "radioButton1" ) );
    textLabel1->setText( tr2i18n( "<font color=\"#0000ff\">It seems you are running KSmoothDock 3.5.1 for the first time!<br>\n"
"Please choose your initial basic setup.</font>" ) );
    textLabel2->setText( tr2i18n( "<font color=\"#aa0000\">Note: you can always change these options (as well as other options) later by right-click on the dock,\n"
"then click on \"Edit Preferences\".</font>" ) );
    pushButton1->setText( tr2i18n( "&OK" ) );
    pushButton1->setAccel( QKeySequence( tr2i18n( "Alt+O" ) ) );
    groupBox2->setTitle( tr2i18n( "The components of KSmoothDock you want to use" ) );
    textLabel6->setText( tr2i18n( "Quick launch menu (always enabled by default)" ) );
    textLabel7->setText( tr2i18n( "Pager" ) );
    textLabel1_3->setText( tr2i18n( "Show windows from all desktops" ) );
    textLabel9->setText( tr2i18n( "Clock" ) );
    textLabel2_3->setText( tr2i18n( "Taskbar" ) );
    cbPager->setText( QString::null );
    cbTaskbar->setText( tr2i18n( "checkBox3" ) );
    cbShowWinAllDesks->setText( tr2i18n( "checkBox5" ) );
    cbClock->setText( tr2i18n( "checkBox4" ) );
    cbQuickLaunch->setText( QString::null );
}

void WelcomeDialog::pushButton1_clicked()
{
  accept();
}

int WelcomeDialog::getZoomMode() {
    int zoomMode = (rbNormalZoom->isOn()) ? NORMAL_ZOOM : PARABOLIC_ZOOM;
    return zoomMode;
}

int WelcomeDialog::getShowPager() {
    int showPager = (cbPager->isChecked()) ? 1 : 0;
    return showPager;
}

int WelcomeDialog::getShowTaskbar() {    
    int showTaskbar = (cbTaskbar->isChecked()) ? 1 : 0;
    return showTaskbar;
}

int WelcomeDialog::getShowClock() {
    int showClock = (cbClock->isChecked()) ? 1 : 0;
    return showClock;
}

int WelcomeDialog::getShowWinAllDesks() {
		int res = (cbShowWinAllDesks->isChecked()) ? 1 : 0;
    return res;
}


#include "welcomedialog.moc"
